#include <cmath>
#include <cstdlib>

using namespace std;

//A fűtés kiszámítása adott ponton
double calcheat(double omega, double t,int k,int l,int N,double theta[],double phi[], double temp[])
{
    //Maximumkereséshez alkalmas tömb létrehozása
    for(int p=0; p<N;p++)
    {
        temp[p]=sin(theta[k])*sin(theta[p])+cos(theta[k])*cos(theta[p])*cos(phi[l]-omega*t);
    }
    double cm=0; //A maximum minimum nulla
    for(int p=0; p<N;p++) //Maximumkeresés
    {
        if(cm<temp[p])
        {
            cm=p;
        }
    }
    return cm;
}

//Egy tömb feltöltése xmin-től xmax-ig N lépésben
void linspace(double *x, int N, double xmin, double xmax)
{
    double dx=(xmax-xmin)/(N-1); //Lépésköz kiszámítása
    for(int k=0; k<N; k++) //Tömb feltöltése
    {
        x[k]=xmin+k*dx;
    }
}

//Mátrixindex konvertálása tömbindexre
int matin(int k, int l, int N)
{
    return N*k+l;
}

//Mátrix inicializálása konstans számmal
void init(double *u, double u0, int N)
{
    for(int k=0;k<N;k++)
    {
        for(int l=0;l<N;l++)
        {
            u[matin(k,l,N)]=u0;
        }
    }
}

//Szférikus laplasz számítása diszkrét pontokra
void lapl(double *lu, double *u, double *theta, double R, int N)
{
    double dph=2*M_PI/(N);  //dPhi lépésköz megállapítása
    double dth=M_PI/(N-1);  //dTheta lépésköz megállapítása
    for(int k=1;k<N-1;k++)  //Végigfutás a tömbön
    {
        for(int l=0;l<N;l++)
        {
            lu[matin(k,l,N)]=
            (
                (u[matin(k-1,l,N)]+u[matin(k+1,l,N)]-2*u[matin(k,l,N)])/dth/dth //  (d^2/dTheta^2) u
                    +(u[matin(k+1,l,N)]-u[matin(k-1,l,N)])/2/dth/tan(theta[k])  //  1/tan(Theta)*(d/dTheta) u
                    +(u[matin(k,(l-1+N)%N,N)]+u[matin(k,(l+1+N)%N,N)]-2*u[matin(k,l,N)])/dph/dph/pow(sin(theta[k]),2) //    1/sin(Theta)^2*(d^2/dPhi^2) u
            )/R/R; // 1/R^2
        }
    }

    //A pólusokon szinguláris a fenti eljárás, de ki lehet használni, hogy ez egy sima felület,
    //ezért a pólusokban lévő értéket a körülötte lévő értékek átlagával közelítem.
    lu[matin(0,0,N)]=0;
    lu[matin(N-1,0,N)]=0;
    for(int l=0;l<N;l++)
    {
        lu[matin(0,0,N)]+=lu[matin(1,l,N)];
        lu[matin(N-1,0,N)]+=lu[matin(N-2,l,N)];
    }

    for(int l=0;l<N;l++)
    {
        lu[matin(0,l,N)]=lu[matin(1,0,N)]/N;
        lu[matin(N-1,l,N)]=lu[matin(N-2,0,N)]/N;
    }
}
